<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKeyValueOfguidstring ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfKeyValueOfguidstring
 * @subpackage Arrays
 */
class ArrayOfKeyValueOfguidstring extends AbstractStructArrayBase
{
    /**
     * The KeyValueOfguidstring
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\KeyValueOfguidstring[]
     */
    public $KeyValueOfguidstring;
    /**
     * Constructor method for ArrayOfKeyValueOfguidstring
     * @uses ArrayOfKeyValueOfguidstring::setKeyValueOfguidstring()
     * @param \patest\StructType\KeyValueOfguidstring[] $keyValueOfguidstring
     */
    public function __construct(array $keyValueOfguidstring = array())
    {
        $this
            ->setKeyValueOfguidstring($keyValueOfguidstring);
    }
    /**
     * Get KeyValueOfguidstring value
     * @return \patest\StructType\KeyValueOfguidstring[]|null
     */
    public function getKeyValueOfguidstring()
    {
        return $this->KeyValueOfguidstring;
    }
    /**
     * This method is responsible for validating the values passed to the setKeyValueOfguidstring method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKeyValueOfguidstring method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKeyValueOfguidstringForArrayConstraintsFromSetKeyValueOfguidstring(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKeyValueOfguidstringKeyValueOfguidstringItem) {
            // validation for constraint: itemType
            if (!$arrayOfKeyValueOfguidstringKeyValueOfguidstringItem instanceof \patest\StructType\KeyValueOfguidstring) {
                $invalidValues[] = is_object($arrayOfKeyValueOfguidstringKeyValueOfguidstringItem) ? get_class($arrayOfKeyValueOfguidstringKeyValueOfguidstringItem) : sprintf('%s(%s)', gettype($arrayOfKeyValueOfguidstringKeyValueOfguidstringItem), var_export($arrayOfKeyValueOfguidstringKeyValueOfguidstringItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KeyValueOfguidstring property can only contain items of type \patest\StructType\KeyValueOfguidstring, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KeyValueOfguidstring value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\KeyValueOfguidstring[] $keyValueOfguidstring
     * @return \patest\ArrayType\ArrayOfKeyValueOfguidstring
     */
    public function setKeyValueOfguidstring(array $keyValueOfguidstring = array())
    {
        // validation for constraint: array
        if ('' !== ($keyValueOfguidstringArrayErrorMessage = self::validateKeyValueOfguidstringForArrayConstraintsFromSetKeyValueOfguidstring($keyValueOfguidstring))) {
            throw new \InvalidArgumentException($keyValueOfguidstringArrayErrorMessage, __LINE__);
        }
        $this->KeyValueOfguidstring = $keyValueOfguidstring;
        return $this;
    }
    /**
     * Add item to KeyValueOfguidstring value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\KeyValueOfguidstring $item
     * @return \patest\ArrayType\ArrayOfKeyValueOfguidstring
     */
    public function addToKeyValueOfguidstring(\patest\StructType\KeyValueOfguidstring $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\KeyValueOfguidstring) {
            throw new \InvalidArgumentException(sprintf('The KeyValueOfguidstring property can only contain items of type \patest\StructType\KeyValueOfguidstring, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KeyValueOfguidstring[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\KeyValueOfguidstring|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\KeyValueOfguidstring|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\KeyValueOfguidstring|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\KeyValueOfguidstring|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\KeyValueOfguidstring|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KeyValueOfguidstring
     */
    public function getAttributeName()
    {
        return 'KeyValueOfguidstring';
    }
}
